package org.commonjava.tensor.agg;

import java.util.Map;

import org.apache.maven.graph.common.ref.ProjectRef;
import org.apache.maven.graph.common.ref.ProjectVersionRef;
import org.apache.maven.graph.effective.EProjectGraph;
import org.apache.maven.graph.effective.EProjectWeb;
import org.commonjava.tensor.data.TensorDataException;

public interface GraphAggregator
{

    EProjectGraph connectSubgraphs( EProjectGraph graph, AggregationOptions crawlerConfig )
        throws TensorDataException;

    EProjectWeb connectSubwebs( EProjectWeb graph, AggregationOptions crawlerConfig, ProjectVersionRef... roots )
        throws TensorDataException;

    Map<ProjectRef, ProjectRefCollection> collectProjectReferences( AggregationOptions options, AggregatorConfig config )
        throws TensorDataException;

}